import 'package:flutter/material.dart';

class GoodsShareEdit extends StatelessWidget {
  final String message;
  final VoidCallback onEditorClick;
  final VoidCallback onCopyClick;

  const GoodsShareEdit(this.message,
      {Key key, this.onEditorClick, this.onCopyClick})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      margin: EdgeInsets.only(left: 10, right: 10),
      // padding: EdgeInsets.only(left: 16, top: 10, right: 16, bottom: 10),
      decoration: BoxDecoration(
          color: Color(0xfff8f8f8), borderRadius: BorderRadius.circular(10)),
      width: double.infinity,
      child: Column(
        children: <Widget>[
          Padding(
            padding: const EdgeInsets.only(left: 16, top: 10, right: 16),
            child: Text(
              message,
              style: TextStyle(
                fontSize: 11,
                fontWeight: FontWeight.bold,
              ),
            ),
          ),
          Container(
            padding:
                const EdgeInsets.only(left: 16, top: 6, bottom: 6, right: 16),
            width: double.infinity,
            child: Wrap(
              spacing: 10,
              runSpacing: 6,
              children: <Widget>[
                GoodsShareCheckButton(
                  '标题',
                  isSelected: true,
                ),
                GoodsShareCheckButton(
                  '收益',
                  isSelected: false,
                ),
                GoodsShareCheckButton(
                  '邀请码',
                  isSelected: true,
                ),
                GoodsShareCheckButton(
                  '链接',
                  isSelected: true,
                ),
              ],
            ),
          ),
          Container(
            width: double.infinity,
            height: 0.5,
            color: Color(0xffececec),
          ),
          Container(
            height: 44,
            child: Row(
              children: <Widget>[
                Expanded(
                  child: GestureDetector(
                    child: Container(
                      color: Colors.transparent,
                      child: GoodsShareCheckButton(
                        '编辑模版',
                        isSelected: true,
                      ),
                    ),
                    onTap: onEditorClick,
                  ),
                ),
                Container(
                  width: 0.5,
                  height: 20,
                  color: Color(0xffececec),
                ),
                Expanded(
                  child: GestureDetector(
                    child: Container(
                      color: Colors.transparent,
                      child: GoodsShareCheckButton(
                        '复制文案',
                        isSelected: false,
                      ),
                    ),
                    onTap: onCopyClick,
                  ),
                ),
              ],
            ),
          )
        ],
      ),
    );
  }
}

class GoodsShareCheckButton extends StatelessWidget {
  final String title;
  final bool isSelected;

  const GoodsShareCheckButton(this.title, {Key key, this.isSelected = true})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return UnconstrainedBox(
      child: Row(
        children: <Widget>[
          Container(
            width: 16,
            height: 16,
            margin: EdgeInsets.only(right: 6),
            decoration: BoxDecoration(
              color: isSelected ? Colors.redAccent : Colors.black12,
              borderRadius: BorderRadius.circular(8),
            ),
          ),
          Text(
            title,
            style: TextStyle(
                fontSize: 11,
                color: isSelected ? Colors.redAccent : Color(0xff333333)),
          ),
        ],
      ),
    );
  }
}
